FROM amazonlinux:2022 as openssl-builder

RUN yum update -y -q \
    && yum groupinstall -y "Development Tools" \
    && yum install -y --allowerasing \
       curl \
       libcurl-devel \
       glibc-locale-source \
       hostname \
       perl-FindBin \
       cmake \
       gnupg2 \
       pinentry-tty \
       libstdc++ \
       libstdc++-static \
       which \
    && yum mark install -y \
       perl-lib \
    && yum remove -y git \
    && yum clean all

ENV LANG C.UTF-8
ENV LC_ALL C.UTF-8
RUN localedef -c -f UTF-8 -i C C.UTF-8

# Install OpenSSL
ENV OPENSSL_VERSION 1.1.1q
RUN curl -fsSL "https://www.openssl.org/source/openssl-${OPENSSL_VERSION}.tar.gz" | tar -xzC /tmp \
    && cd /tmp/openssl-${OPENSSL_VERSION} \
    && ./config --prefix=/usr/local/openssl --openssldir=/usr/local/openssl shared zlib \
    && make \
    && make install \
    && rm -rf /tmp/openssl-${OPENSSL_VERSION}

# Link CA certificate directory and bundle
RUN rm -rf /usr/local/openssl/certs \
    && ln -sf /etc/ssl/certs /usr/local/openssl/certs \
    && ln -sf /etc/ssl/cert.pem /usr/local/openssl/cert.pem

# Put OpenSSL directory in the load path
RUN echo "/usr/local/openssl/lib" > /etc/ld.so.conf.d/openssl-local.conf \
    && ldconfig

# Making sure tools pick up proper OpenSSL library location
ENV LD_LIBRARY_PATH /usr/local/openssl/lib
# GCC uses LIBRARY_PATH
ENV LIBRARY_PATH /usr/local/openssl/lib
ENV CPATH /usr/local/openssl/include

FROM openssl-builder as ruby-image

ENV RUBY_CONFIGURE_EXTRA_OPTS='--with-openssl-dir=/usr/local/openssl'
ENV PATH=${PATH}:/usr/local/openssl/bin

<%= Snippets.new(platform: 'arm64', include: %w[versions ruby git]).populate %>

FROM ruby-image as builder

RUN yum update -y -q \
    && yum install -y \
       clang-devel \
       curl-devel \
       expat-devel \
       krb5-devel \
       perl-devel \
       libyaml-devel \
       libffi-devel \
       readline-devel \
       gdbm-devel \
       ncurses-devel \
       libgpg-error-devel \
       libassuan-devel \
    && yum remove -y cmake \
    && yum clean all

# Based on https://gitlab.kitware.com/cmake/cmake/-/issues/20185 suggestions:
RUN curl -fsSL https://github.com/Kitware/CMake/releases/download/v${CMAKE_VERSION}/cmake-${CMAKE_VERSION}.tar.gz | tar -xzC /tmp \
    && cd /tmp/cmake-${CMAKE_VERSION} \
    && ./bootstrap \
        -- \
        -DCMAKE_PREFIX_PATH="/usr/local/openssl" \
    && make \
    && make install

<%= Snippets.new(platform: 'arm64', exclude: %w[ruby cmake git]).populate %>

FROM amazonlinux:2022

ENV PATH=${PATH}:/usr/local/openssl/bin

LABEL org.opencontainers.image.authors="GitLab Inc. <support@gitlab.com>"

COPY --from=builder / /
